; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    include \masm32\macros\macros.asm
    include timers.asm
  
    _TrimLeadingSpaces PROTO :DWORD
    TrimLeadingSpaces PROTO :DWORD
; 
    .data
      ovrhead dd 0      
      buffer0 db 9,9,"                         I'm Larry,",13,10,\
                 9,32,9,32,9," this is my brother darryl,",13,10,\
                 " and this is my other brother darryl.",13,10,0
      buffer1 db LENGTHOF buffer0 dup(0)
    .code
; 
start: 
; 
    invoke szCopy,ADDR buffer0,ADDR buffer1
    print ADDR buffer1
    print chr$(13,10,"_TrimLeadingSpaces:",13,10,13,10)
    invoke _TrimLeadingSpaces,ADDR buffer1
    print ADDR buffer1
    invoke szCopy,ADDR buffer0,ADDR buffer1
    print chr$(13,10,"TrimLeadingSpaces:",13,10,13,10)
    invoke TrimLeadingSpaces,ADDR buffer1
    print ADDR buffer1

    LOOPCOUNT EQU 1000000
    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
    counter_end
    mov   ovrhead,eax

    print chr$(13,10,"_TrimLeadingSpaces: ")
    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke _TrimLeadingSpaces,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10,"TrimLeadingSpaces: ")

    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke TrimLeadingSpaces,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10)

    mov   eax,input(13,10,"Press enter to exit...")
    exit

_TrimLeadingSpaces PROC USES EDI ESI LpBuffer:DWORD
    mov   esi,LpBuffer
    mov   edi,esi               ; Use the supplied buffer
                                ; to condense the text
    ;check start of line    
  linestart:
    ;lodsb
    lob           ; MASM32 macro, fast replacement for lodsb
    cmp   al,20h                ;space?
    jz    linestart
    cmp   al,9                  ;tab?
    jz    linestart

    ;find crlf or end of text
   @@:
    ;stosb
    stb           ; MASM32 macro, fast replacement for stosb
    or    al,al                 ;end of string?
    jz    done
    .if   al == 10              ;lf?
      .if byte ptr[esi+1] == 13 ;cr? 
        movsb                   ;(this is a precaution
                                ;against a reversal of the
                                ;crlf bytes by some editors
      .endif
      jmp   linestart
    .endif
    ;lodsb
    lob           ; MASM32 macro, fast replacement for lodsb
    jmp   @B
  done:
    ret
_TrimLeadingSpaces endp

; 

TrimLeadingSpaces PROC USES EBX EDI ESI LpBuffer:DWORD
    LOCAL LinBuffer[512]:BYTE ; A buffer to hold a line of text
                              ; to parse
    mov ebx, LpBuffer
    lea edi, LinBuffer
    mov edx, ebx              ; edx holds the starting position in the
    xor esi, esi              ; buffer to put the parsed text at.
GetLine:
    mov al, [ebx]             ; move characters from input buffer to the
    mov [edi + esi], al       ; LinBuffer until a LF or end of buffer
    add ebx, 1                ; is found.
    add esi, 1
    test al, al               ; at end of buffer?
    jnz NotEnd
    jmp over
  NotEnd:
    cmp al, 10                ; at end of line?
    jne GetLine
  over:
    xor esi, esi
    sub esi, 1
  ParseBuff:
    add esi ,1
    mov al, [edi + esi]
    cmp al, 32                ; is the char a space?
    ja DoneParse              ; Done is char is a num,letter,or punctuaton
    je ParseBuff              ; get next char if a space
    cmp al, 9                 ; is the char a tab?
    je ParseBuff              ; get next char if a tab
  DoneParse:
    mov ecx, edi              ; get start offset in LinBuff
    add ecx , esi
    xor esi, esi
  MoveBuff:
    mov al, [ecx + esi]       ; put the line back into the input buffer,
    mov [edx], al             ; minus the leading tabs and spaces.
    add edx, 1
    add esi,1
    test al,al                ; are we at the end of input?
    jz Done
    cmp al, 10                ; are we at end of line?
    jne MoveBuff
    xor esi, esi
    jmp GetLine
  Done:
    ret
TrimLeadingSpaces endp

; 
end start
